#! /usr/bin/perl -w
## Binkd stat v0.12 by SeaD (2:5054/84.1)

if (!($log_file = $ARGV[0])) { die "usage: $0 <binkd.log>\n" }

$debug = 0;
$debug_file = "/tmp/binkd.debug";

if ($debug) { open(FDEBUG, ">> " . $debug_file) or die "open($debug_file): $!\n" }

open(FLOG, "< " . $log_file) or die "open($log_file): $!\n";

$num = $snum = $rnum = $senta = $recva = $scpsa = $rcpsa = $snuma = $rnuma = 0;
$unknown = $empty = $timeout = $passwd = $error = 0;
while (<FLOG>) {
    if (/.*(addr:) ([\.\/:0-9]+)\@(fidonet).*/) {
        $link = $2;
        for ($n = 0; $n < $num; $n++) { if ($lnk[$n] eq $link) { last }
        } if ($n == $num) {
            $lnk[$n] = $link;
            $snt[$n] = $rcv[$n] = $scps[$n] = $rcps[$n] = 0;
            $snum[$n] = $rnum[$n] = $sok[$n] = $sno[$n] = 0; $num++
        } next
    }
    if (/.*(sent:) (.+?) \(([0-9]+), ([0-9]+)\.[0-9][0-9] CPS, ([\.\/:0-9]+)\@(fidonet)\).*/) {
        $link = $5; $sent = $3; $cps = $4;
        for ($n = 0; $n < $num; $n++) {
            if ($lnk[$n] eq $link) {
                $snt[$n] += $sent; $scps[$n] += $cps; $snum[$n]++; last
            }
        } if ($n == $num) { if ($debug) { print FDEBUG } die } next
    }
    if (/.*(rcvd:) (.+?) \(([0-9]+), ([0-9]+)\.[0-9][0-9] CPS, ([\.\/:0-9]+)\@(fidonet)\).*/) {
        $link = $5; $recv = $3; $cps = $4;
        for ($n = 0; $n < $num; $n++) {
            if ($lnk[$n] eq $link) {
                $rcv[$n] += $recv; $rcps[$n] += $cps; $rnum[$n]++; last
            }
        } if ($n == $num) { if ($debug) { print FDEBUG } die } next
    }
    if (/.*(done) \([a-z]+ ([\.\/:0-9]+)\@(fidonet), ([a-zA-Z]+), S\/R: ([0-9]+)\/([0-9]+) \(([0-9]+)\/([0-9]+) (bytes)\).*/) {
        $link = $2; $res = $4; $sent = $7; $recv = $8;
        if (!$sent && !$recv) { if ($debug) { print FDEBUG } $empty++ }
        for ($n = 0; $n < $num; $n++) {
            if ($lnk[$n] eq $link) { $senta += $sent; $recva += $recv; last }
        }
        if ($n == $num) { if ($debug) { print FDEBUG } die }
        if ($res eq "OK") { $sok[$n]++ } else { $sno[$n]++ } next
    }
    if (/done /) { if ($debug) { print FDEBUG } $unknown++ }
    if (/timeout!/) { if ($debug) { print FDEBUG } $timeout++ }
    if (/inconsistent pwd/) { if ($debug) { print FDEBUG } $passwd++ }
    if (/unexpected password digest/) { if ($debug) { print FDEBUG } $passwd++ }
    if (/unable to connect/) { if ($debug) { print FDEBUG } $error++ }
    if (/error/) { if ($debug) { print FDEBUG } $error++ }
}

close(FLOG);

printf("%-16s  %-16s  %-10s  %-10s  %-8s\n", "= link", "= session  (bad)", "= sent", "= recv", "= cps");
printf("%-16s  %-16s  %-10s  %-10s  %-8s\n", "================", "================", "==========", "==========", "========");

$sent = $recv = $sessok = $sessno = 0;
for ($n = 0; $n < $num; $n++) {
    if ($snum[$n] || $rnum[$n]) {
        $cps = ($scps[$n] + $rcps[$n]) / ($snum[$n] + $rnum[$n])
    } else { if (!$sok[$n] && !$sno[$n]) { next } $cps = 0 }
    printf("%-16s  %10u (%-3u)  %10u  %10u  %8u\n", $lnk[$n], $sok[$n], $sno[$n], $snt[$n], $rcv[$n], $cps);
    $sent += $snt[$n]; $recv += $rcv[$n];
    $scpsa += $scps[$n]; $rcpsa += $rcps[$n];
    $snuma += $snum[$n]; $rnuma += $rnum[$n];
    $sessok += $sok[$n]; $sessno += $sno[$n];
}

if ($snuma || $rnuma) { $cps = ($scpsa + $rcpsa) / ($snuma + $rnuma) } else { $cps = 0 }
printf("%-16s  %-16s  %-10s  %-10s  %-8s\n", "================", "================", "==========", "==========", "========");
printf("%-16s  %10u (%-3u)  %9.2fk  %9.2fk  %8u\n", "= total", ($sessok+$sessno), $sessno, ($sent/1024), ($recv/1024), $cps);
print "\n";

if ($snuma) { $scps = $scpsa / $snuma } else { $scps = 0 }
if ($rnuma) { $rcps = $rcpsa / $rnuma } else { $rcps = 0 }
printf("sent: %.2fk (%u cps), recv: %.2fk (%u cps)\n",
    ($senta/1024), $scps, ($recva/1024), $rcps);
printf("empty: %u, unknown: %u, timeout: %u, password: %u, error: %u\n",
    $empty, $unknown, $timeout, $passwd, $error);

if ($debug) { close(FDEBUG) }
