#! /usr/bin/perl -w
## Qico stat v0.12 by SeaD (2:5054/84.1)

if (!($log_file = $ARGV[0])) { die "usage: $0 <qico.log>\n" }
if ($ARGV[1]) { $week = 1 } else { $week = 0 }

$debug = 0;
$debug_file = "/tmp/qico.debug";

if ($debug) { open(FDEBUG, ">> " . $debug_file) or die "open($debug_file): $!\n" }

open(FLOG, "< " . $log_file) or die "open($log_file): $!\n";

if (!$week) {
    printf("%-16s  %-18s  %-8s  %-10s  %-10s  %-6s\n", "= link", "= time", "= dur", "= sent", "= recv", "= cps");
    printf("%-16s  %-18s  %-8s  %-10s  %-10s  %-6s\n", "================", "==================", "========", "==========", "==========", "======");
}

$all = $bad = $ha = $ma = $sa = 0;
$snta = $rcva = $cpsa = $cnum = $num = 0;
while (!eof(FLOG)) {
    while (<FLOG>) {
        if (/([0-9]+) ([A-Za-z]+) ([0-9]+) ([\:0-9]+) .*(answering incoming call).*/) {
            $day = $1, $mon = $2; $year = $3; $time = $4; $all++; last
        }
    }
    while (<FLOG>) {
        if (/.*(exiting with rc).*/) { if ($debug) { print FDEBUG } die }
        if (/.*(address:) ([\.\/:0-9]+).*/) { $link = $2; last }
    }
    for ($n = 0; $n < $num; $n++) { if ($lnk[$n] eq $link) { last } }
    if ($n == $num) {
        $lnk[$n] = $link; $num++;
        $ctot[$n] = $cbad[$n] = $h[$n] = $m[$n] = $s[$n] = 0;
        $snt[$n] = $scs[$n] = $snum[$n] = 0;
        $rcv[$n] = $rcs[$n] = $rnum[$n] = 0;
    } $sent = $recv = $scps = $rcps = 0;
    while (<FLOG>) {
        if (/.*(exiting with rc).*/) { if ($debug) { print FDEBUG } die }
        if (/.*(total:) ([\:0-9]+) online, ([0-9]+)[bkM] sent, ([0-9]+)[bkM] received.*/) {
            $dur = $2; ($hour, $min, $sec) = split(":", $dur);
            $h[$n] += $hour; $m[$n] += $min; $s[$n] += $sec;
            if ($s[$n] > 59) { $s[$n] -= 60; $m[$n]++ }
            if ($m[$n] > 59) { $m[$n] -= 60; $h[$n]++ }
            $ha += $hour; $ma += $min; $sa += $sec;
            if ($sa > 59) { $sa -= 60; $ma++ }
            if ($ma > 59) { $ma -= 60; $ha++ }
            $ctot[$n]++; last
        }
        if (/.*(sent:) (.+?), ([0-9]+) bytes.*?, ([0-9]+) cps \[(.+)\].*/) {
            $sent += $3; if ($scps < $4) { $scps = $4 }
            $snt[$n] += $3; $scs[$n] += $4; $snum[$n]++;
            $snta += $3; $cpsa += $4; $cnum++; next
        }
        if (/.*(recd:) (.+?), ([0-9]+) bytes.*?, ([0-9]+) cps \[(.+)\].*/) {
            $recv += $3; if ($rcps < $4) { $rcps = $4 }
            $rcv[$n] += $3; $rcs[$n] += $4; $rnum[$n]++;
            $rcva += $3; $cpsa += $4; $cnum++; next
        }
    }
    while (<FLOG>) {
        if (/.*(exiting with rc).*/) { if ($debug) { print FDEBUG } die }
        if (/.*(session with) ([\.\/:0-9]+) ([a-z]+) \[(.+)\].*/) {
            if ($scps) {
                if ($rcps) { $cps = ($scps + $rcps) / 2 }
                else { $cps = $scps }
            } else {
                if ($rcps) { $cps = $rcps } else { $cps = 0 }
            }
            if (!$week) {
                printf("%-16s  %-18s  %02u:%02u:%02u  %10u  %10u  %6u\n",
                    $lnk[$n], ($year . " " . $mon . " " . $day . " " . $time), $hour , $min , $sec, $sent, $recv, $cps);
            }
            if ($3 ne "successful") { $cbad[$n]++; $bad++ } last
        }
    }
}

close(FLOG);

if (!$week) {
    if ($cnum) { $cps = $cpsa / $cnum } else { $cps = 0 }
    printf("%-16s  %-18s  %-8s  %-10s  %-10s  %-6s\n", "================", "==================", "========", "==========", "==========", "======");
    printf("%-16s  sess (bad): %2u (%u)  %02u:%02u:%02u  %9.2fk  %9.2fk  %6u\n", "= total", $all, $bad, $ha , $ma , $sa, ($snta/1024), ($rcva/1024), $cps);
    print "\n";
}

if ($week) {
    printf("%-16s  %-16s  %-8s  %-10s  %-10s  %-6s\n", "= link", "= session (bad)", "= dur", "= sent", "= recv", "= cps");
    printf("%-16s  %-16s  %-8s  %-10s  %-10s  %-6s\n", "================", "================", "========", "==========", "==========", "======");
}

$sent = $recv = $cpsa = $cnuma = $ha = $ma = $sa = $sesall = $sesbad = 0;
for ($n = 0; $n < $num; $n++) {
    $sent += $snt[$n]; $recv += $rcv[$n];
    $sesall += $ctot[$n]; $sesbad += $cbad[$n];
    $cps = $cnum = 0;
    $cps += $scs[$n]; $cps += $rcs[$n];
    $cnum += $snum[$n]; $cnum += $rnum[$n];
    $cpsa += $cps; $cnuma += $cnum;
    $ha += $h[$n]; $ma += $m[$n]; $sa += $s[$n];
    if ($sa > 59) { $sa -= 60; $ma++ }
    if ($ma > 59) { $ma -= 60; $ha++ }
    if ($week) {
        if ($cnum) { $cps = $cps / $cnum } else { $cps = 0 }
        printf("%-16s  %9u (%-3u)   %02u:%02u:%02u  %10u  %10u  %6u\n", $lnk[$n], $ctot[$n], $cbad[$n], $h[$n] , $m[$n] , $s[$n], $snt[$n], $rcv[$n], $cps);
    }
}

if ($week) {
    if ($cnuma) { $cps = $cpsa / $cnuma } else { $cps = 0 }
    printf("%-16s  %-16s  %-8s  %-10s  %-10s  %-6s\n", "================", "================", "========", "==========", "==========", "======");
    printf("%-16s  %9u (%-3u)   %02u:%02u:%02u  %9.2fk  %9.2fk  %6u\n", "= total", $sesall, $sesbad, $ha , $ma , $sa, ($sent/1024), ($recv/1024), $cps);

    print "\n";
}

open(FLOG, "< " . $log_file) or die "open($log_file): $!\n";

$cnum = $call = $cmax = $done = $suc = $bad = $fbad = 0; $cmin = 100000;
$snum = $sall = $smax = $sent = 0; $smin = 100000;
$rnum = $rall = $rmax = $recv = 0; $rmin = 100000;
$hour = $min = $sec = 0;
while (<FLOG>) {
    if (/.*(\*\*\* CONNECT )([0-9]+).*/) {
        if ($2 > $cmax) { $cmax = $2 } if ($2 < $cmin) { $cmin = $2 }
        $call += $2; $cnum++; next
    }
    if (/.*(sent:) (.+?), ([0-9]+) bytes.*?, ([0-9]+) cps \[(.+)\].*/) {
        if ($4 > $smax) { $smax = $4 } if ($4 < $smin) { $smin = $4 }
        $sent += $3; $sall += $4; $snum++;
        if ($5 ne "ok") { $fbad++ } next
    }
    if (/.*(recd:) (.+?), ([0-9]+) bytes.*?, ([0-9]+) cps \[(.+)\].*/) {
        if ($4 > $rmax) { $rmax = $4 } if ($4 < $rmin) { $rmin = $4 }
        $recv += $3; $rall += $4; $rnum++;
        if ($5 ne "ok") { $fbad++ } next
    }
    if (/.*(total:) ([\:0-9]+) online, ([0-9]+)[bkM] sent, ([0-9]+)[bkM] received.*/) {
        ($h, $m, $s) = split(":", $2);
        $hour += $h; $min += $m; $sec += $s;
        if ($sec > 59) { $sec -= 60; $min++ }
        if ($min > 59) { $min -= 60; $hour++ }
        next
    }
    if (/.*(session with) ([\.\/:0-9]+) ([a-z]+) \[(.+)\].*/) {
        if ($3 eq "successful") { $suc++ } next
    }
    if (/.*(exiting with rc=)([0-9]+).*/) { $done++; if ($2) { $bad++ } next }
}

close(FLOG);

if ($cnum) {
    printf("connect: %u, speed (max/min/avg): %u/%u/%u\n", $cnum, $cmax, $cmin, ($call/$cnum));
}
if ($snum) {
    printf("sent: %.2fk, cps (max/min/avg): %u/%u/%u\n", ($sent/1024), $smax, $smin, ($sall/$snum));
}
if ($rnum) {
    printf("recv: %.2fk, cps (max/min/avg): %u/%u/%u\n", ($recv/1024), $rmax, $rmin, ($rall/$rnum));
}
if ($cnum) {
    printf("time: %02u:%02u:%02u, done: %u, success: %u, bad (file): %u (%u)\n", $hour, $min, $sec, $done, $suc, $bad, $fbad);
}

if ($debug) { close(FDEBUG) }
